
float4x4 matProj		: Projection;
//float4x4 matView		: View;
float4x4 matWorld		: World;



//////////////////////////////////////////////////////////////////////////////
//					2D Texture Shader										//
//////////////////////////////////////////////////////////////////////////////
//SetFVF( D3DFVF_XYZRHW | TEX1 )
float4 g_texCol		:Color;
struct VS_INPUT2D
{
    float3 Pos : POSITION;
    float2 Tex : TEXCOORD0;    
};

struct VS_OUTPUT2D
{
    float4 Pos		: POSITION;	
    float4 Color	: COLOR0;
    float2 Tex0		: TEXCOORD0;
};

struct PS_INPUT2D
{
    float4 Color    : COLOR0;
    float4 Tex  : TEXCOORD0;
};

struct PS_OUTPUT2D
{
    float4 Color    : COLOR0;
};

texture DecalTexture2D;
sampler DecalSampler2D = sampler_state{
	Texture = (DecalTexture2D);
	MinFilter = NONE;
	MagFilter = NONE;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

VS_OUTPUT2D basic2DMainVS( VS_INPUT2D Input )
{
    VS_OUTPUT2D Out;

    Out.Pos = mul( float4(Input.Pos, 1.0f), matWorld);
    Out.Pos = mul( Out.Pos, matProj );

    Out.Color = g_texCol;

    Out.Tex0 = Input.Tex;

    return Out;
}

PS_OUTPUT2D Basic2DMainPS( PS_INPUT2D Input, uniform bool b_tex )
{
    PS_OUTPUT2D Out;
    
    if( b_tex )
    {
        Out.Color = Input.Color * tex2D( DecalSampler2D, Input.Tex );
    }
    else
    {   
        Out.Color = Input.Color;
    }
    
    return Out;
}

technique BasicTech
{
    pass P0
    {
        VertexShader = compile vs_2_0 basic2DMainVS();
        PixelShader  = compile ps_2_0 Basic2DMainPS(true);

        AlphaBlendEnable = True;
        SrcBlend     = SRCALPHA;
        DestBlend    = INVSRCALPHA;
    }
    pass P1
    {
        VertexShader = compile vs_2_0 basic2DMainVS();
        PixelShader  = compile ps_2_0 Basic2DMainPS(false);

        AlphaBlendEnable = True;
        SrcBlend     = SRCALPHA;
        DestBlend    = INVSRCALPHA;
	}
}